;+----------------------------------------------------------------------
;| Title		: myAVR Grundgerst fr ATmega8
;+----------------------------------------------------------------------
;| Funktion		: ...
;| Schaltung	: ...
;+----------------------------------------------------------------------
;| Prozessor	: ATmega8
;| Takt		: 3,6864 MHz
;| Sprache       	: Assembler
;| Datum         	: ...
;| Version       	: 1.0
;| Autor         	: Paul Preusker
;+----------------------------------------------------------------------
.include	"AVR.H"
;------------------------------------------------------------------------
;Reset and Interrupt vector             ;VNr.  Beschreibung
	rjmp	main	;1   POWER ON RESET
	reti		;2   Int0-Interrupt
	reti		;3   Int1-Interrupt
	reti		;4   TC2 Compare Match
	reti		;5   TC2 Overflow
	reti		;6   TC1 Capture
	reti		;7   TC1 Compare Match A
	reti		;8   TC1 Compare Match B
	reti		;9   TC1 Overflow
	reti		;10  TC0 Overflow
	reti		;11  SPI, STC Serial Transfer Complete
	reti		;12  UART Rx Complete
	reti		;13  UART Data Register Empty
	reti		;14  UART Tx Complete
	reti		;15  ADC Conversion Complete
	reti		;16  EEPROM Ready
	reti		;17  Analog Comparator
	reti		;18  TWI (IC) Serial Interface
	reti		;19  Store Program Memory Ready
;------------------------------------------------------------------------
;Start, Power ON, Reset
main:	ldi	r16,lo8(RAMEND)
	out	SPL,r16
	ldi	r16,hi8(RAMEND)
	out	SPH,r16
	
	ldi	r21,0b00011000	;1 - PORTD
	ldi	r22,0b01101100	;2 - PORTD
	ldi	r23,0b00111100	;3 - PORTD
	ldi	r24,0b10011000	;4 - PORTD
	ldi	r25,0b10110100	;5 - PORTD
	ldi	r26,0b11110100	;6 - PORTD
	
	cbi	DDRB,4	;Pin B4 Taster1 Eingang
	cbi	DDRB,5	;Pin B5 Taster2 Eingang
	ldi	r16,0b00110000	;PullUp fr Taster
	out	PORTB,r16	;PullUp auf PortB
	
	ldi	r16,0b11111111	;Initialisierung der Anzeigen
	out	DDRD,r16
	ldi	r16,0b11111111	;Initialisierung der Anzeigen
	out	DDRC,r16
	ldi	r30,0b00000001	;1 Lauf-Bit
	
;------------------------------------------------------------------------

mainloop:	
	
getKey:	in	r15,PINB	;Taster 1 gedrckt?
	sbrc	r15,4
	rjmp	getKey	;nein Sprung zu getKey
	ldi	r27,0b00100010	;ja
	ldi	r28,0b00100011
weiter:	rcall	myWait_20ms
	rol	r30   	;jetzt Bit-Rotation
	sbrs	r30,7	;Bit an Position 7?
	rjmp 	Zahl1	;nein sprung zu Zahlenausgabe
	ldi	r30,0b00000001	;ja Bit zurcksetzen
	rjmp	getKey	;sprung zu getKey

getKey2:	in	r15,PINB	;Taster 2 gedrckt?
	sbrc	r15,5
	rjmp	getKey2	;nein Sprung zu getKey2
	ldi	r27,0b00010010	;ja
	ldi	r28,0b00010011
	rcall	myWait_20ms	;Sprung zur Warteschleife
	rol	r30   
  	sbrs	r30,7	;Bit an Position 7?
	rjmp 	Zahl11	;nein sprung zu Zahlenausgabe
	ldi	r30,0b00000001	;ja Bit zurcksetzen
	rjmp	getKey2	;sprung zu getKey2

;-----------Tastersperre-------------------------------------------------	

Taster1:	in	r15,PINB	;Taster 1 gedrckt?
	sbrc	r15,4	
	rjmp	getKey2	;nein sprung zu getKey2
	rjmp	getKey	;ja sprung zu getKey
	
Taster2:	in	r15,PINB	;Taster 2 gedrckt?
	sbrc	r15,5
	rjmp	getKey	;nein sprung zu getKey
	rjmp	getKey2	;ja sprung zu getKey2
	

;-----------Zahlenausgabe Taster 1---------------------------------------	
	
Zahl1:	sbrs	r30,1	;Bit an stelle 1
	rjmp 	Zahl2	;nein Sprung
	out	PORTC,r27	;ja ausgabe
	out	PORTD,r21
	rjmp	Taster1	;Sprung anderer Spieler
	
Zahl2:	sbrs	r30,2	;Bit an stelle 2
	rjmp 	Zahl3	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r22
	rjmp	Taster1	;Sprung anderer Spieler
	
Zahl3:	sbrs	r30,3	;Bit an stelle 3
	rjmp 	Zahl4	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r23
	rjmp	Taster1	;Sprung anderer Spieler
	
Zahl4:	sbrs	r30,4	;Bit an stelle 4
	rjmp 	Zahl5	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r24
	rjmp	Taster1	;Sprung anderer Spieler
	
Zahl5:	sbrs	r30,5	;Bit an stelle 5
	rjmp 	Zahl6	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r25
	rjmp	Taster1	;Sprung anderer Spieler
	
Zahl6:	sbrs	r30,6	;Bit an stelle 6
	rjmp 	Taster1	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r26
	rjmp	getKey	;Sprung nachmal Wrfeln
	
	
;-----------Zahlenausgabe Taster 2---------------------------------------

Zahl11:	sbrs	r30,1	;Bit an stelle 1
	rjmp 	Zahl22	;nein Sprung
	out	PORTC,r27	;ja ausgabe
	out	PORTD,r21
	rjmp	Taster2	;Sprung anderer Spieler
	
Zahl22:	sbrs	r30,2	;Bit an stelle 2
	rjmp 	Zahl33	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r22
	rjmp	Taster2	;Sprung anderer Spieler
	
Zahl33:	sbrs	r30,3	;Bit an stelle 3
	rjmp 	Zahl44	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r23
	rjmp	Taster2	;Sprung anderer Spieler
	
Zahl44:	sbrs	r30,4	;Bit an stelle 4
	rjmp 	Zahl55	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r24
	rjmp	Taster2	;Sprung anderer Spieler
	
Zahl55:	sbrs	r30,5	;Bit an stelle 5
	rjmp 	Zahl66	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r25
	rjmp	Taster2	;Sprung anderer Spieler
	
Zahl66:	sbrs	r30,6	;Bit an stelle 6
	rjmp 	mainloop	;nein Sprung
	out	PORTC,r28	;ja ausgabe
	out	PORTD,r26
	rjmp	getKey2	;Sprung nochmal Wrfeln
	
myWait_20ms:
	push	r16
	ldi	r16,0b00000010
	
myWait_20ms_3:
	push	r16
	ldi	r16,0b10000000
	
myWait_20ms_2:
	push	r16
	ldi	r16,0b10000000
	
myWait_20ms_1:
	dec	r16
	brne	myWait_20ms_1
	pop	r16
	dec	r16
	brne	myWait_20ms_2
	pop	r16
	dec	r16
	brne	myWait_20ms_3
	pop	r16
	ret

; 1 C:0b00000000  D:0b00011000
; 2 C:0b00000001  D:0b01101100
; 3 C:0b00000001  D:0b00111100
; 4 C:0b00000001  D:0b10011000
; 5 C:0b00000001  D:0b10110100
; 6 C:0b00000001  D:0b11110100